QT       += core gui 3dcore 3drender 3dinput 3dlogic 3dextras 3danimation

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets printsupport serialport

CONFIG += c++11

# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

# MacOs app icon
ICON = src/entrypoints/groundstation/assets/icons/SkywardHub.icns

# Windows app icon
RC_ICONS = src/entrypoints/groundstation/assets/icons/SkywardHub.ico

INCLUDEPATH += \
    src/shared \
    libs/mavlink-skyward-lib

SOURCES += \
    src/shared/Modules/CsvLogger/CsvLogger.cpp \
    src/shared/Modules/Empty/EmptyModule.cpp \
    src/shared/Modules/ValuesConverterViewer/ValuesViewerConfigPanel.cpp \
    src/shared/Modules/ValuesConverterViewer/ValueElement.cpp \
    src/shared/Modules/ValuesConverterViewer/ValuesConverterViewerModule.cpp \
    src/shared/Modules/OutgoingMessagesViewer/OutgoingMessagesViewerModule.cpp \
    src/shared/Modules/TimerController/TimerControllerModule.cpp \
    src/shared/Modules/OrientationVisualizer/OrientationVisualizer.cpp \
    src/shared/Modules/SkywardHub/PrefabViewElement.cpp \
    src/shared/Modules/SkywardHub/PrefabDialog.cpp \
    src/shared/Modules/SkywardHub/DeployerPathPicker.cpp \
    src/shared/Modules/SkywardHub/Deployer.cpp \
    src/shared/Modules/SkywardHub/SkywardHubModule.cpp \
    src/shared/Modules/StateViewer/StateViewer.cpp \
    src/shared/Modules/Graph/Graph.cpp \
    src/shared/Modules/Test/TestModule.cpp \
    src/shared/Modules/ModulesList.cpp \
    src/shared/Modules/Splitter/Splitter.cpp \
    src/shared/Modules/DefaultModule/DefaultModule.cpp \
    src/shared/Modules/CommandPad/CommandPad.cpp \
    src/shared/Modules/CommandPad/MessageFormElement.cpp \
    src/shared/Modules/MainWindow/SkywardHubMainWindow.cpp \
    src/shared/Modules/MainWindow/Window.cpp \
    src/shared/Modules/IncomingMessagesViewer/IncomingMessagesViewerModule.cpp \
    src/shared/Modules/CompactCommandPad/CompactCommandPad.cpp \
    src/shared/Modules/CompactCommandPad/SendThread.cpp \
    src/shared/Modules/CompactCommandPad/CommandSelector.cpp \
    src/shared/Modules/Tabs/TabsModule.cpp \
    src/shared/Modules/ModuleInfo.cpp \
    src/shared/Modules/Mavlink/MavlinkWriter.cpp \
    src/shared/Modules/Mavlink/MavlinkReader.cpp \
    src/shared/Modules/Mavlink/MavlinkCommandAdapter.cpp \
    src/shared/Modules/Mavlink/MavlinkModule.cpp \
    src/shared/Modules/Mavlink/MavlinkRocketMsgTestingModule.cpp \
    src/shared/Core/EventHandler/EventHandler.cpp \
    src/shared/Core/XmlObject.cpp \
    src/shared/Core/QCustomPlot/QCustomPlot.cpp \
    src/shared/Core/MessageBroker/MessageBroker.cpp \
    src/shared/Core/Module/Module.cpp \
    src/shared/Core/SkywardHubCore.cpp \
    src/shared/Core/Message/Filter.cpp \
    src/shared/Core/Message/Field.cpp \
    src/shared/Core/Message/Topic.cpp \
    src/shared/Core/Message/Message.cpp \
    src/shared/Core/ModulesManager/ModulesManager.cpp \
    src/shared/Components/ContextMenuSeparator/ContextMenuSeparator.cpp \
    src/shared/Components/FilterSelector/FilterSelector.cpp \
    src/shared/Components/ModulesPicker/ModulesPicker.cpp \
    src/shared/Components/SaveConfigurationDialog/SaveConfigurationDialog.cpp \
    src/shared/Components/ErrorDisplayer/Error.cpp \
    src/shared/Components/ErrorDisplayer/ErrorDisplayer.cpp \
    src/shared/Components/ToggleButton/ToggleButton.cpp \
    src/shared/Components/SubscriptionsPanel/SubscriptionsPanel.cpp \
    src/entrypoints/groundstation/main.cpp

HEADERS += \
    src/shared/Modules/CsvLogger/CsvLogger.h \
    src/shared/Modules/Empty/EmptyModule.h \
    src/shared/Modules/ValuesConverterViewer/ValueElement.h \
    src/shared/Modules/ValuesConverterViewer/ValuesViewerConfigPanel.h \
    src/shared/Modules/ValuesConverterViewer/ValuesConverterViewerModule.h \
    src/shared/Modules/OutgoingMessagesViewer/OutgoingMessagesViewerModule.h \
    src/shared/Modules/TimerController/TimerControllerModule.h \
    src/shared/Modules/ModuleInfo.h \
    src/shared/Modules/OrientationVisualizer/OrientationVisualizer.h \
    src/shared/Modules/SkywardHub/SkywardHubModule.h \
    src/shared/Modules/SkywardHub/PrefabDialog.h \
    src/shared/Modules/SkywardHub/Deployer.h \
    src/shared/Modules/SkywardHub/DeployerPathPicker.h \
    src/shared/Modules/SkywardHub/PrefabViewElement.h \
    src/shared/Modules/StateViewer/StatesList.h \
    src/shared/Modules/StateViewer/StateViewer.h \
    src/shared/Modules/Graph/Graph.h \
    src/shared/Modules/Test/TestModule.h \
    src/shared/Modules/SkywardHubStrings.h \
    src/shared/Modules/Splitter/Splitter.h \
    src/shared/Modules/DefaultModule/DefaultModule.h \
    src/shared/Modules/CommandPad/MessageFormElement.h \
    src/shared/Modules/CommandPad/CommandPad.h \
    src/shared/Modules/CommandPad/MessagesList.h \
    src/shared/Modules/MainWindow/SkywardHubMainWindow.h \
    src/shared/Modules/MainWindow/Window.h \
    src/shared/Modules/IncomingMessagesViewer/IncomingMessagesViewerModule.h \
    src/shared/Modules/CompactCommandPad/CompactCommandPad.h \
    src/shared/Modules/CompactCommandPad/CommandSelector.h \
    src/shared/Modules/CompactCommandPad/SendThread.h \
    src/shared/Modules/Tabs/TabsModule.h \
    src/shared/Modules/Mavlink/MavlinkReader.h \
    src/shared/Modules/Mavlink/MavlinkRocketMsgTestingModule.h \
    src/shared/Modules/Mavlink/MavlinkWriter.h \
    src/shared/Modules/Mavlink/MavlinkVersionHeader.h \
    src/shared/Modules/Mavlink/MavlinkModule.h \
    src/shared/Modules/Mavlink/MavlinkCommandAdapter.h \
    src/shared/Modules/ModulesList.h \
    src/shared/Core/EventHandler/EventHandler.h \
    src/shared/Core/QCustomPlot/QCustomPlot.h \
    src/shared/Core/MessageBroker/MessageBroker.h \
    src/shared/Core/SkywardHubCore.h \
    src/shared/Core/Module/Module.h \
    src/shared/Core/XmlObject.h \
    src/shared/Core/Message/Message.h \
    src/shared/Core/Message/Filter.h \
    src/shared/Core/Message/Field.h \
    src/shared/Core/Message/Topic.h \
    src/shared/Core/ModulesManager/ModulesManager.h \
    src/shared/Components/ContextMenuSeparator/ContextMenuSeparator.h \
    src/shared/Components/FilterSelector/FilterSelector.h \
    src/shared/Components/ModulesPicker/ModulesPicker.h \
    src/shared/Components/SaveConfigurationDialog/SaveConfigurationDialog.h \
    src/shared/Components/ErrorDisplayer/ErrorDisplayer.h \
    src/shared/Components/ErrorDisplayer/Error.h \
    src/shared/Components/ToggleButton/ToggleButton.h \
    src/shared/Components/SubscriptionsPanel/SubscriptionsPanel.h \

FORMS += \
    src/shared/Modules/Empty/EmptyModule.ui \
    src/shared/Modules/ValuesConverterViewer/ValuesConverterViewerModule.ui \
    src/shared/Modules/ValuesConverterViewer/ValuesViewerConfigPanel.ui \
    src/shared/Modules/OutgoingMessagesViewer/OutgoingMessagesViewerModule.ui \
    src/shared/Modules/TimerController/TimerControllerModule.ui \
    src/shared/Modules/SkywardHub/SkywardHubModule.ui \
    src/shared/Modules/SkywardHub/PrefabViewElement.ui \
    src/shared/Modules/SkywardHub/PrefabDialog.ui \
    src/shared/Modules/SkywardHub/DeployerPathPicker.ui \
    src/shared/Modules/Test/TestModule.ui \
    src/shared/Modules/MainWindow/Window.ui \
    src/shared/Modules/Mavlink/MavlinkRocketMsgTestingModule.ui \
    src/shared/Components/ModulesPicker/ModulesPicker.ui \
    src/shared/Components/SaveConfigurationDialog/SaveConfigurationDialog.ui \

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

RESOURCES += \
    src/entrypoints/groundstation/application.qrc
