#include "ContextMenuSeparator.h"

ContextMenuSeparator::ContextMenuSeparator(QWidget *parent)
    : QWidgetAction(parent)
{
    build();
}

ContextMenuSeparator::ContextMenuSeparator(const QString &txt, QWidget *parent)
    : QWidgetAction(parent)
{
    setText(txt);
    build();
}

ContextMenuSeparator::~ContextMenuSeparator() {}

void ContextMenuSeparator::setHeight(int val) { label.setMaximumHeight(val); }

void ContextMenuSeparator::setText(const QString &txt) { label.setText(txt); }

void ContextMenuSeparator::build()
{
    setHeight(2);
    // grayish style
    label.setStyleSheet("background: #DBDBDB;");
    // possible alignment
    label.setAlignment(Qt::AlignCenter);
    setDefaultWidget(&label);
}
