#pragma once

#include <Core/Message/Message.h>
#include <Core/MessageBroker/MessageBroker.h>
#include <Core/SkywardHubCore.h>

#include <QGridLayout>
#include <QLabel>
#include <QString>
#include <QTime>
#include <QTimer>
#include <QWidget>
#include <QtWidgets>

enum ErrorType
{
    ET_ERROR,
    ET_WARNING,
    ET_INFO,
};

class ErrorDisplayer;

class Error : public QWidget
{
    Q_OBJECT

public:
    Error(ErrorDisplayer* displayer, QString title, QString description,
          ErrorType type, int msecDuration);
    ~Error();
    void incrementCount(int msecDuration);
    bool compareError(QString title, QString description, ErrorType type);

protected:
    void mouseReleaseEvent(QMouseEvent*) override;
    void paintEvent(QPaintEvent* event) override;
    void decrementCount();

private:
    ErrorDisplayer* displayer;
    QLabel titlePrefix;
    QLabel title;
    QLabel description;
    QLabel countLabel;
    QGridLayout layout;
    ErrorType type;
    int count;
};
