#pragma once

#include <Core/Message/Filter.h>

#include <QBoxLayout>
#include <QComboBox>
#include <QList>
#include <QListWidget>
#include <QMap>
#include <QString>

class FilterSelector : public QWidget
{
    Q_OBJECT

public:
    using Handler = std::function<void(const Filter& filter)>;

    static void selectFilter(Handler handler);
    static void selectFilter(const Filter& filter, Handler handler);
    Filter getFilter();

    static QMap<QString, QList<QString>> listOfMessages();

private:
    FilterSelector();
    explicit FilterSelector(const Filter& filter);

    static QMap<QString, QList<QString>> parseMessagesList();
    void setupUi();

    void setTopic(QString topic);

    Filter filter;

    QString currentMessage;
    QListWidget* fieldsWidget;
    QComboBox* topic;

signals:
    void filterSelected(const Filter&);
};
