#pragma once

#include <Core/Module/Module.h>

#include <QDialog>
#include <QPushButton>
#include <QSharedPointer>
#include <QWidget>

namespace Ui
{
class ModulesPicker;
}

class ModulesPicker : public QDialog
{
    Q_OBJECT

public:
    explicit ModulesPicker();
    ~ModulesPicker() override;

    void addModule(const QString& txt);
    void onModuleSelected(Module* module);
    void onModuleSelected(const QString& mName);
    Module* start();

    //    QWidget* toWidget() override;
    //    XmlObject toXmlObject() override;
    //    void fromXmlObject(const XmlObject &xmlObject) override;

signals:
    void moduleSelected(Module* selectedModule);

protected:
    void createAndConnectUI();
    void connectSlot(QPushButton* button);
    void onCreateModuleButtonClick();
    QPushButton* createButton(const QString& name);

private:
    void createSplitter(Qt::Orientation orientation);

    Ui::ModulesPicker* ui;
    Module** selectedModule = nullptr;
};
