#pragma once

#include <QDialog>

namespace Ui
{
class SaveConfigurationDialog;
}

class SaveConfigurationDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SaveConfigurationDialog(QWidget *parent = nullptr);
    ~SaveConfigurationDialog();

    void pickConfigData(QString *name, QString *iconPath, QString *description);
    void setConfigName(const QString &value);
    void setConfigIconPath(const QString &value);
    void setConfigDescription(const QString &value);

protected:
    void onSelectIconPathClicked();
    void onSaveConfigClicked();

    QString getConfigName() const;
    QString getConfigIconPath() const;
    QString getConfigDescription() const;

private:
    Ui::SaveConfigurationDialog *ui;
    QString *name = nullptr, *iconPath = nullptr, *description = nullptr;
};
