#pragma once

#include <stdint.h>

#include <QString>

class Field
{
public:
    enum class Type
    {
        INT,
        UINT,
        DOUBLE,
        STRING,
        EMPTY
    };

    Field();
    explicit Field(int64_t value);
    explicit Field(uint64_t value);
    explicit Field(double value);
    explicit Field(QString value);

    bool operator==(const Field& toCompare) const;

    Type getType() const;

    int64_t getInteger() const;

    uint64_t getUnsignedInteger() const;

    double getDouble() const;

    QString toString() const;

private:
    Type type;
    QString string;

    union
    {
        int64_t signedInteger;
        uint64_t unsignedInteger;
        double floatingPoint;
    };
};