#include "Message.h"

Message::Message() {}

Message::Message(Topic topic) : topic(topic) {}

void Message::setTopic(Topic topic) { this->topic = topic; }

Topic Message::getTopic() const { return topic; }

void Message::setField(QString key, const Field& field) { fields[key] = field; }

Field Message::getField(QString key) const
{
    if (fields.contains(key))
        return fields[key];
    else
        return Field();
}

bool Message::removeField(QString key) { return fields.remove(key); }

void Message::setFields(const QMap<QString, Field>& fields)
{
    this->fields = fields;
}

QMap<QString, Field> Message::getFields() const { return fields; }

void Message::filterFields(const QSet<QString>& fields)
{
    auto copy = this->fields;

    this->fields = QMap<QString, Field>();

    for (auto field : fields.values())
    {
        if (copy.contains(field))
            this->fields[field] = copy[field];
    }
}

QString Message::toString() const
{
    QString str;

    if (fields.size() > 1)
    {
        str += "{\n";

        for (auto key : fields.keys())
            str += "    " + key + ": " + fields[key].toString() + "\n";

        str.append("}");
    }
    else if (fields.size() == 1)
    {
        auto key = fields.keys().first();
        str      = key + ": " + fields[key].toString();
    }

    return str;
}