#pragma once

#include <QMap>
#include <QSet>

#include "Field.h"
#include "Topic.h"

/**
 * @brief Messages associates values to topics.
 */
class Message
{
public:
    Message();
    explicit Message(Topic topic);

    void setTopic(Topic topic);
    Topic getTopic() const;

    void setField(QString key, const Field& field);
    Field getField(QString key) const;
    bool removeField(QString key);

    void setFields(const QMap<QString, Field>& fields);
    QMap<QString, Field> getFields() const;

    void filterFields(const QSet<QString>& fields);

    QString toString() const;

private:
    Topic topic;
    QMap<QString, Field> fields;
};