#pragma once

#include <Core/EventHandler/EventHandler.h>
#include <Core/SkywardHubCore.h>
#include <Core/XmlObject.h>

#include <QWidget>

class Module : public QWidget
{
    Q_OBJECT

public:
    Module(QWidget* parent = nullptr);

    virtual QWidget* toWidget()                            = 0;
    virtual XmlObject toXmlObject()                        = 0;
    virtual void fromXmlObject(const XmlObject& xmlObject) = 0;

    // ModulesManagerProxy& getModuleManager();
    SkywardHubCoreProxy& getCore();
    EventHandler* getEventHandler();

protected:
    // virtual void onManagerSetted(ModulesManager *manager);

private:
    SkywardHubCoreProxy coreProxy;
    EventHandler eventsHandler;
};
