#pragma once

#include <QObject>

#include "XmlObject.h"

class ModulesManager;
class EventHandler;
class MessageBroker;
class Module;

class SkywardHubCore : public QObject
{
    Q_OBJECT

public:
    SkywardHubCore();
    ~SkywardHubCore();

    void init();

    ModulesManager *getModulesManager();
    EventHandler *getEventHandler();
    MessageBroker *getMessageBroker();

    XmlObject getSettings() const;

signals:
    void centralModuleChanged(Module *newModule);

protected:
    void checkDefaultFolders();
    void saveSettings();
    void loadFirstPage();

private:
    ModulesManager *modulesManager     = nullptr;
    EventHandler *moduleEventHandler   = nullptr;
    MessageBroker *moduleMessageBroker = nullptr;

    XmlObject settings;
};

// Singleton instance of SkywardHubCore

class SkywardHubCoreProxy
{

public:
    static SkywardHubCore *getCore();
    SkywardHubCore *operator->() { return getCore(); }

private:
    static SkywardHubCore *core;
};
