#pragma once

#include <Core/XmlObject.h>
#include <Modules/CommandPad/MessageFormElement.h>
#include <Modules/DefaultModule/DefaultModule.h>

#include <QBoxLayout>
#include <QCheckBox>
#include <QComboBox>
#include <QDialog>
#include <QGridLayout>
#include <QLineEdit>
#include <QMap>
#include <QPushButton>
#include <QString>

class CommandSelector : public QDialog
{
    Q_OBJECT

public:
    explicit CommandSelector(DefaultModule* _parent);
    ~CommandSelector();

    XmlObject toXmlObject(XmlObject& obj);
    void fromXmlObject(const XmlObject& xmlObject);

    bool getSelection(QString& label, Message& message,
                      long& continuosSendTimeout);

private:
    void setupUi();

    QString currentMessage;
    QVBoxLayout* outerLayout;
    QLineEdit *lineEdit, *continuosTimeoutEdit;
    QComboBox* messagesListComboBox;
    QMap<QString, MessageFormElement*> formElements;
    QGridLayout* formGridLayout;
    QPushButton* sendButton;
    QCheckBox* continuosCheck;

    bool selected = false;
    QString selectedLabel;
    Message selectedMessage;

    DefaultModule* parent;
};
