#pragma once

#include <Modules/CompactCommandPad/CommandSelector.h>
#include <Modules/DefaultModule/DefaultModule.h>

#include <QTimer>

class CompactCommandPad : public DefaultModule
{
    Q_OBJECT

public:
    explicit CompactCommandPad(QWidget* parent = nullptr);
    ~CompactCommandPad();

    QWidget* toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject& obj) override;

private slots:
    void buttonEditActionTriggered();
    void send();

private:
    void setupUi();
    void addCustomActionsToMenu() override;

    CommandSelector* selector;
    QPushButton* button;
    QTimer* timer;

    QString label;
    bool selected;
    long continuosSendTimeout;
    Message selectedMessage;
};
