#include "SendThread.h"

SendThread::SendThread(MessageBroker* broker, const Message& msg, long timeout)
    : broker(broker), msg(msg), timeout(timeout), toStop(false)
{
    connect(this, &SendThread::finished, this, &SendThread::deleteLater);
    start();
}

void SendThread::requestStop() { toStop = true; }

void SendThread::run()
{
    while (!toStop)
    {
        broker->publish(msg);
        QThread::sleep(timeout);
    }
}
