#include "EmptyModule.h"

#include <Core/ModulesManager/ModulesManager.h>

#include <QAction>
#include <QMessageBox>
#include <QPoint>

#include "Components/ContextMenuSeparator/ContextMenuSeparator.h"
#include "ui_EmptyModule.h"

EmptyModule::EmptyModule() : DefaultModule(), ui(new Ui::EmptyModule)
{
    ui->setupUi(this);
    defaultContextMenuSetup();
    connectUiSlots();
}

EmptyModule::~EmptyModule() { delete ui; }

void EmptyModule::connectUiSlots()
{
    connect(ui->selectPanel_button, &QPushButton::clicked, this,
            &EmptyModule::onSelectPanelClick);
}

void EmptyModule::onSelectPanelClick() { onReplaceClicked(); }

QWidget* EmptyModule::toWidget() { return this; }

XmlObject EmptyModule::toXmlObject()
{
    return XmlObject(getName(ModuleId::EMPTY));
}

void EmptyModule::fromXmlObject(const XmlObject& xmlObject)
{
    Q_UNUSED(xmlObject);
}
