#pragma once

#include <Core/Message/Filter.h>
#include <Modules/DefaultModule/DefaultModule.h>

class IncomingMessagesViewerModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit IncomingMessagesViewerModule(QWidget* parent = nullptr);
    ~IncomingMessagesViewerModule();

    QWidget* toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject& xmlObject) override;

private slots:
    void onSubscribeClicked();
    void onFilterAdded(const Filter& filter);
    void onFilterRemoved(const Filter& filter);

private:
    QTextEdit* edit;
    void setupUi();
    void addCustomActionsToMenu() override;

    QList<Filter> filters;

    bool keepOnlyLastMessage = false;
    QAction* keepOnlyLastMessageAction;
    bool useTimestamp = false;
    QAction* useTimestampAction;
};
