#include "SkywardHubMainWindow.h"

#include <Core/Module/Module.h>
#include <Core/ModulesManager/ModulesManager.h>

#include <QFile>
#include <QMenu>

SkywardHubMainWindow::SkywardHubMainWindow(QWidget* parent)
    : QMainWindow(parent)
{
    QFile styleSheet(":/assets/styles/global.qss");
    styleSheet.open(QFile::ReadOnly);
    setStyleSheet(styleSheet.readAll());

    mainWindow = new Window();
    mainWindow->setWindowTitle("Skyward Hub - 1");
    setCentralWidget(mainWindow);

    connect(core->getModulesManager(), &ModulesManager::contextMenuRequest,
            this, &SkywardHubMainWindow::onContextMenuRequest);
    connect(core->getModulesManager(), &ModulesManager::pageAdded, this,
            &SkywardHubMainWindow::onPageAdded);

    core->init();
}

void SkywardHubMainWindow::onContextMenuRequest(QMenu& menu, const QPoint& pos)
{
    menu.exec(pos);
}

void SkywardHubMainWindow::onPageAdded(int index)
{
    Module* module = core->getModulesManager()->getModuleAt(index);

    if (module != nullptr)
    {
        if (index == 0)
        {
            mainWindow->updateModule(module);
        }
        else
        {
            Window* window = new Window();
            window->setWindowTitle("Skyward Hub - " +
                                   QString::number(index + 1));
            window->setCentralModule(module);
            window->show();
        }
    }
}
