#pragma once

#include <QMenu>
#include <QWidget>

#include "Components/ErrorDisplayer/Error.h"
#include "Components/ErrorDisplayer/ErrorDisplayer.h"

class Module;

namespace Ui
{
class Window;
}

class Window : public QWidget
{
    Q_OBJECT

public:
    explicit Window(QWidget *parent = nullptr);
    ~Window();

    void updateModule(Module *m);
    Module *getCentralModule() const;

    void setCentralModule(Module *value);

    ErrorDisplayer *errorDisplayer;

protected:
    void closeEvent(QCloseEvent *event) override;
    void onWidgetDestroyed();
    void onReplaceRequested(Module *sender, Module *newModule);
    void resizeEvent(QResizeEvent *) override;

private:
    Ui::Window *ui;
    Module *centralModule = nullptr;
};
