#pragma once

#include <Core/Message/Message.h>
#include <Core/ModulesManager/ModulesManager.h>

#include <QMap>
#include <QObject>
#include <QSerialPort>

#include "MavlinkVersionHeader.h"
#include "MavlinkWriter.h"

class MavlinkModule;

/*
 * This class translate commands received from the UI in mavlink messages that
 * can be sent.
 */
class MavlinkCommandAdapter : public QObject
{
    Q_OBJECT

public:
    MavlinkCommandAdapter();

    void send(mavlink_message_t msg);
    void setSerialPort(QSerialPort* value);
    bool encodeCommand(const Message& msg, mavlink_message_t& output);

    bool produceMsgFromXml(const XmlObject& xml, mavlink_message_t* msg);
    static const int MAV_CMP = 96;
    static const int MAV_SYS = 171;

private:
    QSerialPort* serial = nullptr;

    MavlinkWriter mavlinkWriter;
    QMap<QString, int> msgNameIdMap;
};
