#pragma once

#include <QMap>

#include "ModuleInfo.h"

class ModulesList
{
public:
    ModulesList();

    void createModuleList();

    bool containsId(ModuleId id);
    void addModuleInfo(const ModuleInfo &info);

    QString getModuleName(ModuleId id) const;
    std::function<Module *()> getFactory(ModuleId id) const;

    std::function<Module *()> findFactoryByModuleName(const QString &name);
    QList<QString> getModulesNamesList();

    QList<ModuleInfo> getModulesInfo();

private:
    QList<ModuleInfo> modulesInfo;
};
