#pragma once

#include <Modules/DefaultModule/DefaultModule.h>
#include <Qt3DRender/qpointlight.h>

#include <QSizePolicy>
#include <Qt3DCore/QAspectEngine>
#include <Qt3DCore/QEntity>
#include <Qt3DCore/QTransform>
#include <Qt3DExtras/QConeMesh>
#include <Qt3DExtras/QCuboidMesh>
#include <Qt3DExtras/QFirstPersonCameraController>
#include <Qt3DExtras/QForwardRenderer>
#include <Qt3DExtras/QOrbitCameraController>
#include <Qt3DExtras/QPhongMaterial>
#include <Qt3DExtras/QSphereMesh>
#include <Qt3DExtras/QTorusMesh>
#include <Qt3DExtras/Qt3DWindow>
#include <Qt3DInput/QInputAspect>
#include <Qt3DRender/QAttribute>
#include <Qt3DRender/QBuffer>
#include <Qt3DRender/QCamera>
#include <Qt3DRender/QCameraLens>
#include <Qt3DRender/QGeometry>
#include <Qt3DRender/QGeometryRenderer>
#include <Qt3DRender/QRenderAspect>

class OrientationVisualizer : public DefaultModule
{
    Q_OBJECT

public:
    explicit OrientationVisualizer(QWidget *parent = nullptr);

    QWidget *toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &xmlObject) override;

private:
    QLabel *rollLabel, *pitchLabel, *yawLabel;

    Qt3DCore::QTransform *rocketTransform;

    void updateOrientation(double qx, double qy, double qz, double qw);
    void setupUi();

    void drawLine(const QVector3D &start, const QVector3D &end,
                  const QColor &color, Qt3DCore::QEntity *rootEntity);

    QQuaternion sceneRotation = {-0.5, -0.5, -0.5, 0.5};
};
