#pragma once

#include <QDialog>

namespace Ui
{
class DeployerPathPicker;
}

class DeployerPathPicker : public QDialog
{
    Q_OBJECT

public:
    explicit DeployerPathPicker(QWidget *parent = nullptr);
    ~DeployerPathPicker();

    bool pickDirectory();

    QString getDeploymentFolder() const;
    QString getProFilePathFolder() const;

    bool getPickConfirmed() const;
    void setPickConfirmed(bool value);

protected slots:
    void onSelectDeployFolderClicked();
    void onSelectProFilePathClicked();

    void setDeploymentFolder(const QString &value);
    void setProFilePathFolder(const QString &value);
    void onConfirmButtonClicked();

private:
    Ui::DeployerPathPicker *ui;
    bool pickConfirmed;
};
