#pragma once

#include <Core/Module/Module.h>
#include <Modules/DefaultModule/DefaultModule.h>

#include <QSplitter>
#include <QWidget>

class Splitter : public DefaultModule
{
    Q_OBJECT

public:
    explicit Splitter(Qt::Orientation orientation = Qt::Horizontal,
                      QWidget *parent             = nullptr);

    QWidget *toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject &obj) override;

    void addModule(Module *module);
    void addModule(Module *module, int position);
    Qt::Orientation getOrientation() const;

    void setOrientation(Qt::Orientation orientation);
    void swapOrientation();

public slots:
    void replace(Module *oldModule, Module *newModule);

private:
    void addCustomActionsToMenu() override;
    void setupUi(Qt::Orientation orientation = Qt::Horizontal);

    QSplitter *splitter;
};
