#pragma once

#include <Core/Message/Filter.h>
#include <Core/Message/Message.h>
#include <Modules/DefaultModule/DefaultModule.h>

#include <QLabel>
#include <QWidget>

#include "StatesList.h"

class StateViewerModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit StateViewerModule(QWidget* parent = nullptr);
    ~StateViewerModule();

    QWidget* toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject& xmlObject) override;

private:
    void setupUi();
    void addCustomActionsToMenu() override;
    void onConfigureClicked();
    void setFilter(const Filter& filter);
    void onMsgReceived(const Message& msg);

    QHBoxLayout* outerLayout;

    Filter filter;
    StatesList::State currentState;
};
