#pragma once

#include <QListWidget>
#include <QStackedWidget>
#include <QWidget>

#include "Modules/DefaultModule/DefaultModule.h"

class TabsModule : public DefaultModule
{
    Q_OBJECT
public:
    TabsModule(QWidget* parent = nullptr);
    ~TabsModule();

    void addTab(const QString& tabName, Module* module);
    QString generateUniqueTabName();

    void addCustomActionsToMenu() override;

    QWidget* toWidget() override;
    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject& xmlObject) override;

protected slots:
    void onTabDeleted(Module* module);
    void replaceTabContent(Module* from, Module* to);
    void onDoubleClickedItem(QListWidgetItem* item);

    void onMenuNewTabClick();
    void onMenuDeleteTabClick();
    void onMenuRenameTabClick();

private:
    QListWidget* tabNames;
    QStackedWidget* tabContents;
    QList<Module*> contentModules;

    /* number of tabs ever created (used for names) */
    unsigned totalTabs = 0;

    void setupUi();
};
