#pragma once

#include <QLabel>
#include <QWidget>

#include "Core/Message/Message.h"
#include "Modules/DefaultModule/DefaultModule.h"
#include "ValueElement.h"

class ValuesViewerConfigPanel;

namespace Ui
{
class ValuesConverterViewerModule;
}

class ValuesConverterViewerModule : public DefaultModule
{
    Q_OBJECT

public:
    explicit ValuesConverterViewerModule(QWidget* parent = nullptr);
    ~ValuesConverterViewerModule();

    QWidget* toWidget() override;

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject& xmlObject) override;

protected:
    void onConfigureClicked();
    void onConfigurationSaved(ValuesViewerConfigPanel* sPanel);
    void addCustomActionsToMenu() override;
    QLabel* createView(const ValueElement& el) const;
    void clearLabels();
    void createLabels();
    void addRule(const ValueElement& el);
    void setRules(const QList<ValueElement>& rList);
    void onMsgReceived(const Message& msg);
    void clearRules();
    int findLabelIndexByName(const QString& name);
    bool isTopicPresent(const QString& topic);

private:
    Ui::ValuesConverterViewerModule* ui;
    int minColNumber = 1;
    int columns      = minColNumber;
    QList<QLabel*> labels;
    QList<ValueElement> rules;
};
