#pragma once

#include <QRadioButton>
#include <QWidget>

#include "ValueElement.h"

namespace Ui
{
class ValuesViewerConfigPanel;
}

class ValuesViewerConfigPanel : public QWidget
{
    Q_OBJECT

public:
    explicit ValuesViewerConfigPanel(QWidget *parent = nullptr);
    ~ValuesViewerConfigPanel();

    int getColumnsCount() const;
    void setColumnsCount(int value);

    void setRules(const QList<ValueElement> &newValues);
    QList<ValueElement> getRules() const;

signals:
    void configurationSaved(ValuesViewerConfigPanel *sPanel);

protected:
    void onAddFieldClicked();
    void onRemoveClicked();
    void onPickColordClicked();
    void onValueElementClicked();
    void onSaveClicked();
    void onEditClicked();
    int computeViewIndex(const QString &viewName);
    QRadioButton *createView(const ValueElement &el);
    void setTextBoxValues(const ValueElement &el);
    int findSelectedView() const;
    void addRule(int index, const ValueElement &el);
    void onEmitRadioButtonToggled(bool val);

    ValueElement createRuleFromControls();

private:
    Ui::ValuesViewerConfigPanel *ui;

    QList<ValueElement> rules;
    QList<QRadioButton *> views;
};
